﻿// Реализация шагов BDD-фич/сценариев c помощью фреймворка https://github.com/artbear/1bdd
#Использовать "../.."

Перем БДД; //контекст фреймворка 1bdd

// Метод выдает список шагов, реализованных в данном файле-шагов
Функция ПолучитьСписокШагов(КонтекстФреймворкаBDD) Экспорт
	БДД = КонтекстФреймворкаBDD;

	ВсеШаги = Новый Массив;

	ВсеШаги.Добавить("ЯСоздаюКомандныйФайл");
	ВсеШаги.Добавить("ЯДобавляюСтрокуВКомандныйФайл");
	ВсеШаги.Добавить("ЯСообщаюСодержимоеКомандногоФайла");
	ВсеШаги.Добавить("ЯВыполняюКомандныйФайл");
	ВсеШаги.Добавить("ВыводКомандногоФайлаСодержит");
	ВсеШаги.Добавить("КодВозвратаКомандногоФайлаРавен");

	Возврат ВсеШаги;
КонецФункции

// Реализация шагов

// Процедура выполняется перед запуском каждого сценария
Процедура ПередЗапускомСценария(Знач Узел) Экспорт
	
КонецПроцедуры

// Процедура выполняется после завершения каждого сценария
Процедура ПослеЗапускаСценария(Знач Узел) Экспорт
	
КонецПроцедуры

//Я создаю командный файл
Процедура ЯСоздаюКомандныйФайл() Экспорт
	КомандныйФайл = Новый КомандныйФайл; 
	КомандныйФайл.Создать();
	БДД.СохранитьВКонтекст("КомандныйФайл", КомандныйФайл);
КонецПроцедуры

//я добавляю строку "echo командный файл" в командный файл
Процедура ЯДобавляюСтрокуВКомандныйФайл(Знач СтрокаКоманды) Экспорт
	КомандныйФайл = БДД.ПолучитьИзКонтекста("КомандныйФайл");

	КомандныйФайл.ДобавитьКоманду(СтрокаКоманды);
КонецПроцедуры

//Я выполняю командный файл
Процедура ЯВыполняюКомандныйФайл() Экспорт
	КомандныйФайл = БДД.ПолучитьИзКонтекста("КомандныйФайл");

	КомандныйФайл.Исполнить();
КонецПроцедуры

//Я сообщаю содержимое файла "ИмяФайла"
Процедура ЯСообщаюСодержимоеФайла(Знач ИмяФайла) Экспорт
	ВывестиТекстФайла(ИмяФайла);
КонецПроцедуры

//Я сообщаю содержимое командного файла
Процедура ЯСообщаюСодержимоеКомандногоФайла() Экспорт
	КомандныйФайл = БДД.ПолучитьИзКонтекста("КомандныйФайл");

	ТекстФайла = КомандныйФайл.ПолучитьТекстФайла();
	Сообщить(ТекстФайла);
КонецПроцедуры

//Вывод командного файла содержит "командный файл"
Процедура ВыводКомандногоФайлаСодержит(Знач ОжидаемыйВыводКоманды) Экспорт
	КомандныйФайл = БДД.ПолучитьИзКонтекста("КомандныйФайл");

	ВыводКоманды = КомандныйФайл.ПолучитьВывод();
	Ожидаем.Что(ВыводКоманды).Содержит(ОжидаемыйВыводКоманды);
КонецПроцедуры

//Код возврата командного файла равен 0
Процедура КодВозвратаКомандногоФайлаРавен(Знач ОжидаемыйКодВозврата) Экспорт
	КомандныйФайл = БДД.ПолучитьИзКонтекста("КомандныйФайл");

	Ожидаем.Что(КомандныйФайл.ПолучитьКодВозврата(), "Код возврата").Равно(ОжидаемыйКодВозврата);
КонецПроцедуры


Процедура ВывестиТекстФайла(Знач ИмяФайла, Знач Кодировка = Неопределено)

	Файл = Новый Файл(ИмяФайла);
	Если НЕ Файл.Существует() Тогда
		Возврат;
	КонецЕсли;
	
	Если Кодировка = Неопределено Тогда
		Кодировка = "utf-8";
	КонецЕсли;
	
	ЧТ = Новый ЧтениеТекста(ИмяФайла, Кодировка);
	СтрокаФайла = ЧТ.Прочитать();
	ЧТ.Закрыть();
	
	Сообщить(СтрокаФайла);

КонецПроцедуры
